# remirepo/fedora spec file for php-cs-fixer
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    dcf644315abc557e006ce068d299f85d17ec2157
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
#global gh_date      20150717
%global gh_owner     FriendsOfPHP
%global gh_project   PHP-CS-Fixer
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-cs-fixer
Version:        2.2.14
Release:        1%{?gh_date:.%{gh_date}git%{gh_short}}%{?dist}
Summary:        A tool to automatically fix PHP code style

Group:          Development/Tools
License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
# git snapshot to get upstream test suite
Source0:        %{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

# Use our autoloader
Patch0:         %{name}-autoload.patch

BuildArch:      noarch
%if %{with_tests}
# For tests
BuildRequires:  php(language) >= 5.4
BuildRequires:  php-tokenizer
BuildRequires:  php-composer(composer/semver)          <  2
BuildRequires:  php-composer(composer/semver)          >= 1.4
BuildRequires:  php-composer(doctrine/annotations)     <  2
BuildRequires:  php-composer(doctrine/annotations)     >= 1.2
BuildRequires:  php-composer(gecko-packages/gecko-php-unit) <  3
BuildRequires:  php-composer(gecko-packages/gecko-php-unit) >= 2.0
BuildRequires:  php-symfony-console
BuildRequires:  php-symfony-event-dispatcher
BuildRequires:  php-symfony-filesystem
BuildRequires:  php-symfony-finder
BuildRequires:  php-symfony-options-resolver
BuildRequires:  php-composer(symfony/polyfill-php55)   <  2
BuildRequires:  php-composer(symfony/polyfill-php55)   >= 1.4
BuildRequires:  php-composer(symfony/polyfill-php70)   <  2
BuildRequires:  php-composer(symfony/polyfill-php70)   >= 1.4
BuildRequires:  php-composer(symfony/polyfill-php72)   <  2
BuildRequires:  php-composer(symfony/polyfill-php72)   >= 1.4
BuildRequires:  php-symfony-process
BuildRequires:  php-symfony-stopwatch
BuildRequires:  php-composer(sebastian/diff)           <  2
BuildRequires:  php-composer(sebastian/diff)           >= 1.4
BuildRequires:  php-mbstring
BuildRequires:  php-xml
BuildRequires:  php-reflection
BuildRequires:  php-dom
BuildRequires:  php-json
BuildRequires:  php-pcre
BuildRequires:  php-phar
BuildRequires:  php-spl
BuildRequires:  php-xml
# From composer.json,     "require-dev": {
# NOTICE: listener disabled
#        "johnkary/phpunit-speedtrap": "^1.0.1",
#        "justinrainbow/json-schema": "^5.0",
#        "keradus/cli-executor": "^1.0",
#        "mikey179/vfsStream": "^1.6",
#        "satooshi/php-coveralls": "^1.0.2",
#        "phpunit/phpunit": "^4.8.35 || ^5.4.3",
#        "symfony/phpunit-bridge": "^3.2 || ^4.0"
BuildRequires:  php-composer(justinrainbow/json-schema) <  6
BuildRequires:  php-composer(justinrainbow/json-schema) >= 5
#BuildRequires: php-composer(keradus/cli-executor) <  2
#BuildRequires: php-composer(keradus/cli-executor) >= 1
BuildRequires:  php-composer(mikey179/vfsStream) <  2
BuildRequires:  php-composer(mikey179/vfsStream) >= 1.6
BuildRequires:  php-composer(phpunit/phpunit) >= 4.8.35
BuildRequires:  php-symfony-phpunit-bridge
# Autoloader
BuildRequires:  php-fedora-autoloader-devel
%endif

# From composer.json,     "require": {
#        "php": "^5.3.6 || >=7.0 <7.3",
#        "ext-json": "*",
#        "ext-tokenizer": "*",
#        "composer/semver": "^1.4",
#        "doctrine/annotations": "^1.2",
#        "gecko-packages/gecko-php-unit": "^2.0",
#        "sebastian/diff": "^1.4",
#        "symfony/console": "^2.4 || ^3.0",
#        "symfony/event-dispatcher": "^2.1 || ^3.0 || ^4.0",
#        "symfony/filesystem": "^2.4 || ^3.0 || ^4.0",
#        "symfony/finder": "^2.2 || ^3.0 || ^4.0",
#        "symfony/options-resolver": "^2.6 || ^3.0 || ^4.0",
#        "symfony/polyfill-php54": "^1.0",
#        "symfony/polyfill-php55": "^1.3",
#        "symfony/polyfill-php70": "^1.0",
#        "symfony/polyfill-php72": "^1.4",
#        "symfony/process": "^2.3 || ^3.0 || ^4.0",
#        "symfony/stopwatch": "^2.5 || ^3.0 || ^4.0"
# use 5.4 to avoid polyfill
Requires:       php(language) >= 5.4
Requires:       php-json
Requires:       php-tokenizer
Requires:       php-composer(composer/semver)          <  2
Requires:       php-composer(composer/semver)          >= 1.4
Requires:       php-composer(doctrine/annotations)     <  2
Requires:       php-composer(doctrine/annotations)     >= 1.2
Requires:       php-composer(gecko-packages/gecko-php-unit) <  3
Requires:       php-composer(gecko-packages/gecko-php-unit) >= 2.0
Requires:       php-composer(sebastian/diff)           <  2
Requires:       php-composer(sebastian/diff)           >= 1.4
Requires:       php-symfony-console
Requires:       php-symfony-event-dispatcher
Requires:       php-symfony-filesystem
Requires:       php-symfony-finder
Requires:       php-symfony-options-resolver
Requires:       php-composer(symfony/polyfill-php55)   <  2
Requires:       php-composer(symfony/polyfill-php55)   >= 1.4
Requires:       php-composer(symfony/polyfill-php70)   <  2
Requires:       php-composer(symfony/polyfill-php70)   >= 1.4
Requires:       php-composer(symfony/polyfill-php72)   <  2
Requires:       php-composer(symfony/polyfill-php72)   >= 1.4
Requires:       php-symfony-process
Requires:       php-symfony-stopwatch
# From composer.json, "suggest": {
#        "ext-mbstring": "For handling non-UTF8 characters in cache signature.",
#        "symfony/polyfill-mbstring": "When enabling `ext-mbstring` is not possible."
Requires:       php-mbstring
# From phpcompatinfo report for version 2.2.5
Requires:       php-cli
Requires:       php-reflection
Requires:       php-dom
Requires:       php-pcre
Requires:       php-phar
Requires:       php-spl
Requires:       php-xml
# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       php-composer(friendsofphp/php-cs-fixer) = %{version}


%description
The PHP Coding Standards Fixer tool fixes most issues in your code when you
want to follow the PHP coding standards as defined in the PSR-1 and PSR-2
documents and many more.

If you are already using a linter to identify coding standards problems in
your code, you know that fixing them by hand is tedious, especially on large
projects. This tool does not only detect them, but also fixes them for you.


%prep
%setup -q -n %{gh_project}-%{gh_commit}
%patch0 -p1 -b .rpm

# from composer.json, "autoload" / "classmap"
TESTS="
  tests/TestCase.php
  tests/Test/AbstractFixerTestCase.php
  tests/Test/AbstractIntegrationTestCase.php
  tests/Test/IntegrationCase.php
  tests/Test/IntegrationCaseFactory.php
"
for i in $TESTS; do
  mkdir -p src/$(dirname $i)
  cp -p $i src/$i
done

# fix dev-tools path
sed -e 's:../../../dev-tools/::' -i src/Console/Command/HelpCommand.php
cp -pr dev-tools/ci-integration.sh  src/Console/Command/

phpab --template fedora --output src/autoload.php src/tests

cat << 'EOF' | tee -a src/autoload.php

require_once '%{php_home}/Fedora/Autoloader/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('PhpCsFixer\\', __DIR__);
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Composer/Semver/autoload.php',
    '%{php_home}/Doctrine/Common/Annotations/autoload.php',
    '%{php_home}/GeckoPackages/PHPUnit/autoload.php',
    '%{php_home}/Symfony/Component/autoload.php',
    '%{php_home}/SebastianBergmann/Diff/autoload.php',
    '%{php_home}/Symfony/Polyfill/autoload.php',
]);
EOF


%build
# Empty build section, most likely nothing required.


%install
: Library
mkdir -p   %{buildroot}%{php_home}
cp -pr src %{buildroot}%{php_home}/PhpCsFixer

: Command
install -Dpm755 %{name} %{buildroot}%{_bindir}/%{name}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Symfony/Bridge/PhpUnit/autoload.php',
    '%{php_home}/org/bovigo/vfs/autoload.php',
    '%{php_home}/JsonSchema5/autoload.php',
    '%{buildroot}%{php_home}/PhpCsFixer/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('PhpCsFixer\\Tests\\', dirname(__DIR__) . '/tests');
EOF

# Ignore integration test
sed -e "/README.rst/s:__DIR__.*':'$PWD/README.rst':" \
    -i tests/Console/Command/ReadmeCommandTest.php
# use keradus/cli-executor
rm tests/Smoke/CiIntegrationTest.php
rm tests/Smoke/StdinTest.php

# Disable listener
sed -e 's/listeners/nolistener/' phpunit.xml.dist >phpunit.xml

# Redirect to buildroot
sed -e 's:%{php_home}:%{buildroot}%{php_home}:' -i %{name}

# see https://github.com/FriendsOfPHP/PHP-CS-Fixer/blob/master/.travis.yml
if php -r 'exit (version_compare(PHP_VERSION, "5.6", "<") ? 0 : 1);'; then
  export SKIP_LINT_TEST_CASES=1
fi

%{_bindir}/phpunit -d memory_limit=1G --verbose
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc composer.json
%doc *.md *.rst
%{php_home}/PhpCsFixer
%{_bindir}/%{name}


%changelog
* Thu Jan 11 2018 Remi Collet <remi@remirepo.net> - 2.2.14-1
- Update to 2.2.14

* Wed Dec 13 2017 Remi Collet <remi@remirepo.net> - 2.2.13-1
- Update to 2.2.13

* Mon Nov 27 2017 Remi Collet <remi@remirepo.net> - 2.2.12-1
- Update to 2.2.12

* Mon Nov 20 2017 Remi Collet <remi@remirepo.net> - 2.2.11-1
- Update to 2.2.11

* Fri Nov 10 2017 Remi Collet <remi@remirepo.net> - 2.2.10-1
- Update to 2.2.10

* Fri Nov  3 2017 Remi Collet <remi@remirepo.net> - 2.2.9-1
- Update to 2.2.9

* Mon Oct  2 2017 Remi Collet <remi@remirepo.net> - 2.2.8-1
- Update to 2.2.8

* Tue Sep 12 2017 Remi Collet <remi@remirepo.net> - 2.2.7-1
- Update to 2.2.7
- add dependency on composer/semver

* Wed Aug 23 2017 Remi Collet <remi@remirepo.net> - 2.2.6-1
- Update to 2.2.6

* Thu Aug  3 2017 Remi Collet <remi@remirepo.net> - 2.2.5-1
- add dependency on symfony/polyfill-php72
- Update to 2.2.5

* Thu May 25 2017 Remi Collet <remi@remirepo.net> - 2.2.4-1
- Update to 2.2.4
- add dependency on gecko-packages/gecko-php-unit
- only Symfony 2

* Wed Apr 26 2017 Remi Collet <remi@remirepo.net> - 2.2.3-1
- Update to 2.2.3

* Mon Apr 24 2017 Remi Collet <remi@remirepo.net> - 2.2.2-1
- Update to 2.2.2
- raise dependency on sebastian/diff >= 1.4

* Mon Apr 10 2017 Remi Collet <remi@remirepo.net> - 2.2.1-1
- Update to 2.2.1

* Sat Apr  1 2017 Remi Collet <remi@remirepo.net> - 2.2.0-1
- Update to 2.2.0
- add dependency on doctrine/annotations
- add dependency on symfony/options-resolver
- raise dependency on symfony 2.6
- fix autoloader to allow Symfony 3

* Fri Mar 31 2017 Remi Collet <remi@remirepo.net> - 2.1.3-1
- Update to 2.1.3
- add dependency on php-mbstring

* Wed Mar 15 2017 Remi Collet <remi@remirepo.net> - 2.1.2-1
- Update to 2.1.2

* Sat Feb 11 2017 Remi Collet <remi@fedoraproject.org> - 2.1.0-1
- update to 2.1.0
- add dependency on symfony/polyfill-php55 (for EPEL-7)

* Thu Feb  9 2017 Remi Collet <remi@fedoraproject.org> - 2.0.1-1
- update to 2.0.1

* Thu Dec  1 2016 Remi Collet <remi@fedoraproject.org> - 2.0.0-1
- update to 2.0.0

* Tue Nov 29 2016 Remi Collet <remi@fedoraproject.org> - 1.13.0-1
- update to 1.13.0

* Tue Nov 15 2016 Remi Collet <remi@fedoraproject.org> - 1.12.4-1
- update to 1.12.4

* Sun Oct 30 2016 Remi Collet <remi@fedoraproject.org> - 1.12.3-1
- update to 1.12.3
- switch from symfony/class-loader to fedora/autoloader

* Tue Sep 27 2016 Remi Collet <remi@fedoraproject.org> - 1.12.2-1
- update to 1.12.2

* Fri Sep  9 2016 Remi Collet <remi@fedoraproject.org> - 1.12.1-1
- initial package, version 1.12.1

